class Csource;

class Cfunction : public Cclassmember {
public:
	static Cfunction	*g_hash[HASHSIZE];
	static unsigned int	g_hash_cnt;

	Cfunction	*m_hashP;
	char		*m_demangleP;
	int			m_vtable;

	Cfunction(const char *nameP);

	static void			reset(void);
	static Cfunction	*local_exists(const char *nameP, Centity *parentP);
	static Cfunction	*global_exists(const char *nameP);
	static Cfunction	*locate(const char *nameP, int flags, Csource *sourceP);
	static void			resolve(void);

	const char 		*get_type(void) const;

	virtual objectE	type(void) const;
	virtual void	emit_id(void) const;
	virtual void	print(void) const;

	virtual void	emit_instance(void) const;
	virtual void	emit_edges(void);
	void			emit_attributes(void) const;
};

